﻿@page "/outbound"

@inject HttpClient Client
@using SwP.Fulfillment.ParcelLogger.Shared
@using System.Text.Json.Serialization;
@using System.Text.Json;
@inject NavigationManager NavigationManager
@inject ISnackbar Snackbar


<MudStack>
    <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
        <Animation AnimationNameSelect="fade-in">
            <MudFab  Color="Color.Primary" StartIcon="@Icons.Material.Filled.Add" Size="Size.Large" Disabled=@_disableCreation OnClick="Add"></MudFab>
        </Animation>
    </MudContainer>
    <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
        <MudTable @ref="_mudTable" Items="@_batchList.OrderByDescending(x => x.DateCreated)" Hover="true" Breakpoint="Breakpoint.Sm" RowClassFunc="@SelectedRowClassFunc" OnRowClick="@((TableRowClickEventArgs<RecordsList> x) => { RowClickEvent(x); })">
            <HeaderContent>
                <MudTh>Batch ID</MudTh>
                <MudTh>Name</MudTh>
                <MudTh>Creation Date</MudTh>
                <MudTh>Records</MudTh>
                <MudTd></MudTd>
            </HeaderContent>
            <RowTemplate>
                <MudTd DataLabel="Batch ID" HideSmall>@context.Id</MudTd>
                <MudTd DataLabel="Name">@context.Description</MudTd>
                <MudTd DataLabel="Creation Date">@context.DateCreated.ToString("dd.MM.yyyy HH:mm:ss")</MudTd>
                <MudTd DataLabel="Records">@context.Records.Count</MudTd>
                <MudTd DataLabel="State">
                    @if (context.Locked)
                    {
                        <MudIcon Icon="@Icons.Material.Outlined.Lock" Color="Color.Success" />
                    }
                    else if (context.Edited)
                    {
                        <MudIcon Icon="@Icons.Material.Filled.EditNote" Color="Color.Warning" />
                    }
                </MudTd>
            </RowTemplate>
        </MudTable>
    </MudContainer>
</MudStack>



@code {
    int _selectedRowNumber = -1;
    MudTable<RecordsList> _mudTable;
    bool _disableCreation = true;

    List<RecordsList> _batchList = new();
    protected override async Task OnInitializedAsync()
    {
        try
        {
            _batchList = await Client.GetFromJsonAsync<List<RecordsList>>("api/outbounds", new JsonSerializerOptions() { ReferenceHandler = ReferenceHandler.IgnoreCycles });
            //_disableCreation = false;

        }
        catch 
        {
            var errorMsg = "Error fetching data from API. Please try again.";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
        }
    }

    void RowClickEvent(TableRowClickEventArgs<RecordsList> row)
    {
        if (row.Item.Locked != true)
        {
            NavigationManager.NavigateTo($"./outbound/scanner/{row.Item.Id}", true);
        }
    }

    private string SelectedRowClassFunc(RecordsList batch, int rowNumber)
    {
        if (_selectedRowNumber == rowNumber)
        {
            _selectedRowNumber = -1;
            //clickedEvents.Add("Selected Row: None");
            return string.Empty;
        }
        else if (_mudTable.SelectedItem != null && _mudTable.SelectedItem.Equals(batch))
        {
            _selectedRowNumber = rowNumber;
            //clickedEvents.Add($"Selected Row: {rowNumber}");
            return "selected";
        }
        else
        {
            return string.Empty;
        }
    }
    void Add()
    {
        NavigationManager.NavigateTo($"./outbound/addlist", true);
    }

}
